<?php

/* MapSetting fr MapCreator
 * Backend- Verwaltungsmodul mit Geokodierer zum Erstellen und Bearbeiten der MapCreator.ini
 *
 * @version 1.2
 * @author Matthias Fleischer
 * @copyright 2008 by MFD|WEB http://www.mfdweb.de
 * @lizenz CreativeCommons cc-by-sa 3.0 de (Namensnennung-Weitergabe unter gleichen Bedingungen 3.0 Deutschland) http://creativecommons.org/licenses/by-sa/3.0/de/
 */

include "../../../backend/sessionheader.inc.php";
include "../../../edit/config.inc.php";
if (!defined('MAPCREATOR') || MAPCREATOR == false) die ('<p>MapCreator nicht freigeschaltet</p>');
if (empty($_SESSION['rights']) || $_SESSION['rights'] < 3) die();

define('INIPATH', '../../../minibot/MapCreator.ini');
$ini_file = realpath(INIPATH);

if (isset($_POST['Speichern'])) {
    $APIkey = urlencode($_POST['APIkey']);
    if (is_numeric($_POST['MAPlat'])) $MAPlat = $_POST['MAPlat'];
    else $fehler = true;
    if (is_numeric($_POST['MAPlng'])) $MAPlng = $_POST['MAPlng'];
    else $fehler = true;
    $MAPinfo = str_replace('"', "'", $_POST['MAPinfo']);
    $MAPzoom = $_POST['MAPzoom'];
    if (ctype_digit($_POST['MAPbreite'])) $MAPbreite = substr($_POST['MAPbreite'], 0, 3);
    else $fehler = true;
    if (ctype_digit($_POST['MAPhoehe'])) $MAPhoehe = substr($_POST['MAPhoehe'], 0, 3);
    else $fehler = true;
    $MAPtype = $_POST['MAPtype'];
    if ($_POST['MAPMapC'] == "on") $MAPMapC = $_POST['MAPMapC'];
    else $MAPMapC = "off";
    if ($_POST['MAPTypeC'] == "on") $MAPTypeC = $_POST['MAPTypeC'];
    else $MAPTypeC = "off";
    if ($_POST['MAPScaleC'] == "on") $MAPScaleC = $_POST['MAPScaleC'];
    else $MAPScaleC = "off";
    if ($_POST['MAPOverview'] == "on") $MAPOverview = $_POST['MAPOverview'];
    else $MAPOverview = "off";
    $Zoom[$MAPzoom] = " selected";
    $Type[$MAPtype] = " selected";
    if ($MAPMapC == 'on') $MapC = " checked";
    if ($MAPTypeC == 'on') $TypeC = " checked";
    if ($MAPScaleC == 'on') $ScaleC = " checked";
    if ($MAPOverview == 'on') $Overview = " checked";
    if (empty($APIkey) or $APIkey == '0') $inputs = " readonly=\"readonly\"";
    if (empty($fehler)) {
        if (is_writeable(INIPATH)) { // Prft ob MapCreator.ini beschreibbar
            $inifile = fopen(INIPATH, 'w');
            $eintrag = "APIkey=$APIkey\r\nMAPlat=$MAPlat\r\nMAPlng=$MAPlng\r\nMAPinfo=$MAPinfo\r\nMAPzoom=$MAPzoom\r\nMAPbreite=$MAPbreite\r\nMAPhoehe=$MAPhoehe\r\nMAPtype=$MAPtype\r\nMAPMapC=$MAPMapC\r\nMAPTypeC=$MAPTypeC\r\nMAPScaleC=$MAPScaleC\r\nMAPOverview=$MAPOverview";
            if (!fwrite($inifile, $eintrag)) $meldung = "<div style=\"color:#8F1111; background-color:#FFCFCF; border:1px #8F1111 outset; padding-left:15px\" onclick=\"javascript:this.style.display='none'\"><p><b>Fehler: Die Daten konnten nicht gespeichert werden!</b></p></div>";
            else $meldung = "<div style=\"color:#077F00; background-color:#CFFFDF; border:1px #077F00 outset; padding-left:15px\" onclick=\"javascript:this.style.display='none'\"><p><b>Meldung: Die Daten wurden erfolgreich gespeichert!</b></p></div>\n";
            fclose($inifile);
        } else $meldung = "<div style=\"color:#8F1111; background-color:#FFCFCF; border:1px #8F1111 outset; padding-left:15px\" onclick=\"javascript:this.style.display='none'\"><p><b>Fehler: Die Systemdatei</b> $ini_file <b>ist nicht beschreibbar!</b></p></div>";
    } else $meldung = "<div style=\"color:#FFA200; background-color:#FFFCDF; border:1px #FFA200 outset; padding-left:15px\" onclick=\"javascript:this.style.display='none'\"><p><b>Hinweis: Fehlerhafte Daten! Bitte prfen Sie Ihre Eingaben!</b></p></div>";
} else {
    if (file_exists(INIPATH)) { // Prft ob MapCreator.ini vorhanden
        $inifile = fopen(INIPATH, 'r');
        while (!feof($inifile)) { // Holt Werte aus MapCreator.ini
            $inipart = explode('=', trim(fgets($inifile)));
            $mapset[$inipart[0]] = $inipart[1];
        }
        fclose($inifile);
        extract($mapset); // $APIkey, $MAPlat, $MAPlng, $MAPinfo, $MAPzoom, $MAPbreite, $MAPhoehe, $MAPtype, $MAPMapC, $MAPTypeC, $MAPScaleC, $MAPOverview
        $Zoom[$MAPzoom] = " selected";
        $Type[$MAPtype] = " selected";
        if ($MAPMapC == 'on') $MapC = " checked";
        if ($MAPTypeC == 'on') $TypeC = " checked";
        if ($MAPScaleC == 'on') $ScaleC = " checked";
        if ($MAPOverview == 'on') $Overview = " checked";
        if (empty($APIkey) or $APIkey == '0') $inputs = " readonly=\"readonly\"";
    } else $meldung = "<div style=\"color:#8F1111; background-color:#FFCFCF; border:1px #8F1111 outset; padding-left:15px\" onclick=\"javascript:this.style.display='none'\"><p><b>Fehler: Die Systemdatei</b> $ini_file <b>ist nicht vorhanden!</b></p></div>\n";
}
$formular = <<<FORMULAR
<form method="POST" action="">
<fieldset><legend><b>Grundeinstellungen</b></legend>
  <table border="0">
    <tr>
      <th align="right"><a href="http://code.google.com/intl/de/apis/maps/signup.html" title="Anmelden fr das Google Maps-API" target="_blank">Google Maps-APIkey</a></th>
      <td><input type="text" name="APIkey" size="100" value="{$APIkey}" /></td>
    </tr>
    <tr>
      <th align="right">Breitengrad</th>
      <td><input type="text" id="MAPlat" name="MAPlat" size="18" value="{$MAPlat}"{$inputs} /> <a href="http://de.wikipedia.org/wiki/Geographische_Breite" target="_blank">geographische Breite</a> &#966;
        <i>(latitude &gt; lat)</i></td>
    </tr>
    <tr>
      <th align="right">Lngengrad</th>
      <td><input type="text" id="MAPlng" name="MAPlng" size="18" value="{$MAPlng}"{$inputs} /> <a href="http://de.wikipedia.org/wiki/Geographische_Lnge" target="_blank">geographische Lnge</a> &#955;
        <i>(longitude &gt; lng)</i></td>
    </tr>
    <tr>
      <th align="right">Infotext</th>
      <td><input type="text" name="MAPinfo" size="100" value="{$MAPinfo}"{$inputs} /></td>
    </tr>
    <tr>
      <th align="right">Zoomfaktor</th>
      <td><select size="1" name="MAPzoom"{$inputs}>
          <option{$Zoom[0]}>0</option>
          <option{$Zoom[1]}>1</option>
          <option{$Zoom[2]}>2</option>
          <option{$Zoom[3]}>3</option>
          <option{$Zoom[4]}>4</option>
          <option{$Zoom[5]}>5</option>
          <option{$Zoom[6]}>6</option>
          <option{$Zoom[7]}>7</option>
          <option{$Zoom[8]}>8</option>
          <option{$Zoom[9]}>9</option>
          <option{$Zoom[10]}>10</option>
          <option{$Zoom[11]}>11</option>
          <option{$Zoom[12]}>12</option>
          <option{$Zoom[13]}>13</option>
          <option{$Zoom[14]}>14</option>
          <option{$Zoom[15]}>15</option>
          <option{$Zoom[16]}>16</option>
          <option{$Zoom[17]}>17</option>
          <option{$Zoom[18]}>18</option>
          <option{$Zoom[19]}>19</option>
          <option{$Zoom[20]}>20</option>
        </select> 0 = gering <i>(Erde)</i> - 20 = stark <i>(Haus)</i></td>
    </tr>
    <tr>
      <th align="right">Kartenbreite</th>
      <td><input type="text" name="MAPbreite" size="5" maxlength="3" value="{$MAPbreite}"{$inputs} /> px <i>(Pixel)</i></td>
    </tr>
    <tr>
      <th align="right">Kartenhhe</th>
      <td><input type="text" name="MAPhoehe" size="5" maxlength="3" value="{$MAPhoehe}"{$inputs} /> px <i>(Pixel)</i></td>
    </tr>
    <tr>
      <th align="right">Kartentyp</th>
      <td><select size="1" name="MAPtype"{$inputs}>
          <option{$Type[0]} value="0">Karte</option>
          <option{$Type[1]} value="1">Satellit</option>
          <option{$Type[2]} value="2">Hybrid</option>
          <option{$Type[3]} value="3">Gelnde</option>
        </select></td>
    </tr>
    <tr>
      <th align="right">Bedienelemente</th>
      <td><input type="checkbox" name="MAPMapC" value="on"{$MapC}{$inputs} />Steuerung&nbsp;
        <input type="checkbox" name="MAPTypeC" value="on"{$TypeC}{$inputs} />Typauswahl&nbsp;
		<input type="checkbox" name="MAPScaleC" value="on"{$ScaleC}{$inputs} />Mastab&nbsp;
        <input type="checkbox" name="MAPOverview" value="on"{$Overview}{$inputs} />bersichtskarte&nbsp;&nbsp;<i>(Grenabhngig)</i></td>
    </tr>
    <tr>
      <th align="right"><input type="submit" value="Speichern" name="Speichern" onClick="return confirm('Mchten Sie die Einstellungen Speichern?\\nAlle alte Daten werden dabei berschrieben!');" /></th>
      <td><input type="reset" value="Zurcksetzen" name="Zur&uuml;cksetzen" /></td>
    </tr>
  </table>
  </fieldset>
</form>\n
FORMULAR;

if (!empty($APIkey) && $APIkey != '0') {
    $GmapTyp = array('G_NORMAL_MAP', 'G_SATELLITE_MAP', 'G_HYBRID_MAP', 'G_PHYSICAL_MAP'); // Kartentypen 0-3
    $MAP_type = $GmapTyp[$MAPtype];
    $head = "\n<script src=\"http://maps.google.com/maps?file=api&amp;v=2&amp;key={$APIkey}\" type=\"text/javascript\"></script>";
    $kartencode = "<table width=\"100%\" border=\"0\">
  <tr>
    <td width=\"50%\" valign=\"top\">
<fieldset><legend><b>Kartenvorschau</b></legend>
<table width=\"100%\" border=\"0\" cellpadding=\"3\">
  <tr>
    <td>
<div id=\"map\" class=\"karte\" style=\"width:{$MAPbreite}px; height:{$MAPhoehe}px; overflow:hidden\"><noscript>
<img alt=\"Karte\" src=\"http://maps.google.com/staticmap?center={$MAPlat},{$MAPlng}&zoom={$MAPzoom}&size={$MAPbreite}x{$MAPhoehe}&markers={$MAPlat},{$MAPlng}&key={$APIkey}\" />
</noscript></div>
<script type=\"text/javascript\">
//<![CDATA[
  if (GBrowserIsCompatible()) {
    var map = new GMap2(document.getElementById(\"map\"));
    map.addMapType(G_PHYSICAL_MAP);
    map.setMapType({$MAP_type});\n";
    if ($MAPMapC == "on") {
        if ($MAPhoehe > 399) $kartencode .= "    map.addControl(new GLargeMapControl());\n";
        else if ($MAPhoehe > 199) $kartencode .= "    map.addControl(new GSmallMapControl());\n";
        else $kartencode .= "    map.addControl(new GSmallZoomControl());\n";
    }
    if ($MAPTypeC == "on") {
        if ($MAPbreite > 349) $kartencode .= "    map.addControl(new GMapTypeControl());\n";
        else $kartencode .= "    map.addControl(new GMenuMapTypeControl());\n";
    }
    if ($MAPScaleC == "on") {
        $kartencode .= "    map.addControl(new GScaleControl());\n";
    }
    if ($MAPOverview == "on") {
        if ($MAPbreite > 299 && $MAPhoehe > 199) $kartencode .= "    map.addControl(new GOverviewMapControl());\n";
    }
    $kartencode .= "    map.setCenter(new GLatLng({$MAPlat},{$MAPlng}), {$MAPzoom});
	geocoder = new GClientGeocoder();\n";
    $kartencode .= "    var marker = new GMarker(new GLatLng({$MAPlat},{$MAPlng}), {draggable:true});\n";
    if (!empty($MAPinfo)) $kartencode .= "    GEvent.addListener(marker, \"click\", function() { marker.openInfoWindowHtml(\"{$MAPinfo}\"); });\n";
    $kartencode .= "    map.addOverlay(marker);
    function showAddress(address) {
      if (geocoder) {
        geocoder.getLatLng(address, function(point) {
            if (!point) {
              alert(\"Die Position >\" + address + \"< wurde nicht gefunden!\");
            } else {
              if (typeof marker != \"undefined\") marker.hide();
              map.setCenter(point, 14);
              marker = new GMarker(point, {draggable:true});
              map.addOverlay(marker);
              latlng = marker.getLatLng();
              document.getElementById(\"lat\").value = latlng.lat();
              document.getElementById(\"lng\").value = latlng.lng();
			  GEvent.addListener(marker, \"dragend\", function(){
                latlng = marker.getLatLng();
                document.getElementById(\"lat\").value = latlng.lat();
                document.getElementById(\"lng\").value = latlng.lng();
              });
            }
        });
      }
    }
    GEvent.addListener(map, \"click\", function(overlay, latlng) {
      if (latlng) {
        if (typeof marker != \"undefined\") marker.hide();
        marker = new GMarker(latlng, {draggable:true});
        map.addOverlay(marker);
        document.getElementById(\"lat\").value = latlng.lat();
        document.getElementById(\"lng\").value = latlng.lng();
        GEvent.addListener(marker, \"dragend\", function(){
          latlng = marker.getLatLng();
          document.getElementById(\"lat\").value = latlng.lat();
          document.getElementById(\"lng\").value = latlng.lng();
        });
      }
    });
    GEvent.addListener(marker, \"dragend\", function(){
      latlng = marker.getLatLng();
      document.getElementById(\"lat\").value = latlng.lat();
      document.getElementById(\"lng\").value = latlng.lng();
    });
  }
 //]]>
</script>
    </td>
  </tr>
  <tr>
    <td>
<i>So wird die Darstellung aussehen, wenn Sie den Symbolbefehl</i> <code>{map}</code> <i>ohne weitere Parameter benutzen und daher die Grundeinstellungen verwendet werden.</i>
    </td>
  </tr>
</table>
</fieldset>
    </td>
    <td width=\"50%\" valign=\"top\">
<fieldset><legend><b>Geokodierer</b></legend>
<table width=\"100%\" border=\"0\" cellpadding=\"3\">
  <tr>
    <td width=\"100%\" colspan=\"2\">
Um die Geokoordinaten fr einen bestimmten Punkt zu erhalten, geben Sie den gesuchten Ort in das nachfolgende Formularfeld ein (z.B. <i>Ort, Strae</i>). Der jeweilige Fundort, wird dann in der Kartenvorschau angezeigt.
    </td>
  </tr>
  <tr>
    <td width=\"100%\" colspan=\"2\">
  <form onsubmit=\"showAddress(this.address.value); return false\">
    <input type=\"text\" size=\"60\" name=\"address\" value=\"\" />
	<input type=\"submit\" value=\"Finden\" />
  </form>
    </td>
  </tr>
  <tr>
    <td width=\"100%\" colspan=\"2\">
Sie knnen nun den angezeigten Markierungspunkt durch ziehen mit der Maus przisieren, dabei werden die beiden Koordinaten jeweils automatisch aktualisiert.<br/>
Alternativ, knnen Sie auch durch einen einfachen klick in die Karte einen neuen Markierungspunkt an beliebiger Stelle platzieren.
    </td>
  </tr>
  <tr>
    <td nowrap align=\"right\">
  <form onsubmit=\"document.getElementById('MAPlat').value=this.lat.value; document.getElementById('MAPlng').value=this.lng.value; return false\">
    Breitengrad <input type=\"text\" size=\"18\" name=\"lat\" id=\"lat\" readonly=\"readonly\" />&nbsp;<br />
    Lngengrad <input type=\"text\" size=\"18\" name=\"lng\" id=\"lng\" readonly=\"readonly\" />&nbsp;<br />
    <code id=\"code\"></code>
    </td>
    <td>
Wenn Sie mit der Position zufrieden sind, knnen Sie die Koordinaten in das Formular der Grundeinstellungen...<br/>
	<input type=\"submit\" value=\"&Uuml;bernehmen\" onClick=\"return alert('Bitte das anschlieende Speichern nicht Vergessen!');\" />
  </form>
    </td>
  </tr>
</table>
</fieldset>
   </td>
  </tr>
</table>";
} else {
    $kartencode = "<fieldset><legend><b>Erste Schritte</b></legend>
<table width=\"100%\" border=\"0\" cellpadding=\"3\">
  <tr>
    <td width=\"100%\">
Um die Funktionalitt des <strong><a href=\"http://www.mfdweb.de/relinker.php?chiffre=001010\" title=\"MapGrerator by MFD|WEB\">MapCreator</a></strong> nutzen zu knnen, bentigen Sie einen gltigen APIkey fr Ihre Domain.<br/>
Diesen API-Schlssel knnen Sie kostenfrei durch Eingabe Ihrer Adresse: <b>http://$_SERVER[HTTP_HOST]</b> bei <a href=\"http://code.google.com/intl/de/apis/maps/signup.html\" title=\"Anmelden fr das Google Maps-API\" target=\"_blank\">Google Maps</a> generieren.<br/>
Bitte tragen Sie anschlieend diesen APIkey in das obige Formular ein und klicken Sie auf Speichern.
   </td>
  </tr>
</table>
</fieldset>
";
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
 <meta http-equiv="content-type" content="text/html; charset=iso-8859-1"/>
 <title>MapCreator Settings</title><?php echo $head; ?>
</head>
<body>
 <table width="100%" height="40px" border="0">
  <tr>
   <td width="25%"><h1><a style="color:#114477; cursor:help;" href="http://www.mfdweb.de/relinker.php?chiffre=001010" title="MapGrerator by MFD|WEB">MapCreator</a></h1></td>
   <td width="75%"><?php echo $meldung; ?></td>
  </tr>
 </table>
 <?php echo $formular . $kartencode; ?>
 <p><tt>&copy;2008 by <a href="http://www.mfdweb.de/" title="design for all areas of life">MFD|WEB</a> - Lizenz CreativeCommons <a href="http://creativecommons.org/licenses/by-sa/3.0/de/" title="Namensnennung-Weitergabe unter gleichen Bedingungen 3.0 Deutschland">cc-by-sa 3.0 de</a></tt></p>
</body>
</html>